Bug 1654426 - Review Request: rubygem-xdg - dependency of new version of tmuxinator
Summary: Review Request: rubygem-xdg - dependency of new version of tmuxinator
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR
TreeView+ depends on / blocked
 
Reported: 2018-11-28 18:38 UTC by Dillen Meijboom
Modified: 2018-12-02 22:07 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Dillen Meijboom 2018-11-28 18:38:00 UTC
Spec URL: https://copr-be.cloud.fedoraproject.org/results/dmeijboom/rubygem-xdg/fedora-rawhide-x86_64/00831141-rubygem-xdg/rubygem-xdg.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/dmeijboom/rubygem-xdg/fedora-rawhide-x86_64/00831141-rubygem-xdg/rubygem-xdg-2.2.3-1.fc30.src.rpm
Description: A module for supporting the XDG Base Directory Standard
Fedora Account System Username: dmeijboom

I want to update the tmuxinator package to a new version but it depends on this rubygem. This is my first package so I need a sponsor and please let me know if I made a mistake somewhere.

Comment 1 Christopher Brown 2018-11-28 21:44:09 UTC
Hey Dillen,

Looks like a good start. I'm not sure if you have already but you should take a look at the Fedora Ruby packaging page:

https://fedoraproject.org/wiki/Packaging:Ruby

Specifically there is now some magic in later versions of RPM to automatically unpack gems rather than having to do stuff like:

gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec

Take a look at the example spec or one already in use - e.g the one for prawn:

https://src.fedoraproject.org/rpms/rubygem-prawn/blob/master/f/rubygem-prawn.spec

Welcome!

Comment 2 Fabio Valentini 2018-11-28 22:05:20 UTC
Is it possible that you generated your .spec file with an older version of gem2rpm?
The newest version (1.0.1) incorporates some changes to comply with the latest Packaging Guidelines for Ruby.

Comment 3 Dillen Meijboom 2018-11-28 22:33:09 UTC
Thans for the feedback!

I created the first spec file using "RubyGems" as source-type in copr, it seems like the gem2rpm they're using is outdated. I rebuild the package with a new spec file which I created using the gem2rpm command on my machine. It looks like this version is better and more up to date regarding the packaging guidelines.

New Spec URL: https://copr-be.cloud.fedoraproject.org/results/dmeijboom/rubygem-xdg/fedora-rawhide-x86_64/00831203-rubygem-xdg/rubygem-xdg.spec
New SRPM URL: https://copr-be.cloud.fedoraproject.org/results/dmeijboom/rubygem-xdg/fedora-rawhide-x86_64/00831203-rubygem-xdg/rubygem-xdg-2.2.3-1.fc30.src.rpm

Comment 4 Robert-André Mauchin 2018-11-30 19:35:38 UTC
 - License: BSD-2-Clause

   Valid shorthand is BSD:

License: BSD

Comment 5 Robert-André Mauchin 2018-11-30 20:10:26 UTC
 - Run the tests



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD 2-clause "Simplified" License", "*No copyright* BSD
     2-clause "Simplified" License", "Unknown or generated". 31 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/rubygem-xdg/review-rubygem-
     xdg/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

Ruby:
[x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Macro %{gem_extdir} is deprecated.
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Pure Ruby package must be built as noarch
[x]: Package does not contain Requires: ruby(abi).

===== SHOULD items =====

Generic:
[-]: Avoid bundling fonts in non-fonts packages.
     Note: Package contains font files
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
     xdg-doc
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Ruby:
[x]: Gem should use %gem_install macro.
[x]: Gem package should exclude cached Gem.
[x]: gems should not require rubygems package
[x]: Specfile should use macros from rubygem-devel package.
[x]: Test suite should not be run by rake.
[x]: Test suite of the library should be run.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-xdg-2.2.3-1.fc30.noarch.rpm
          rubygem-xdg-doc-2.2.3-1.fc30.noarch.rpm
          rubygem-xdg-2.2.3-1.fc30.src.rpm
rubygem-xdg.noarch: W: invalid-license BSD-2-Clause
rubygem-xdg.noarch: W: no-documentation
rubygem-xdg.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/.index
rubygem-xdg.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/.cache
rubygem-xdg.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/.cache
rubygem-xdg.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.cache
rubygem-xdg.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.cache
rubygem-xdg.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.config
rubygem-xdg.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.config
rubygem-xdg.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.local
rubygem-xdg.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.local
rubygem-xdg-doc.noarch: W: invalid-license BSD-2-Clause
rubygem-xdg-doc.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/.cache
rubygem-xdg-doc.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/.cache
rubygem-xdg-doc.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.cache
rubygem-xdg-doc.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.cache
rubygem-xdg-doc.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.config
rubygem-xdg-doc.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.config
rubygem-xdg-doc.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.local
rubygem-xdg-doc.noarch: W: hidden-file-or-dir /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.local
rubygem-xdg.src: W: invalid-license BSD-2-Clause
3 packages and 0 specfiles checked; 0 errors, 21 warnings.

Comment 6 Dillen Meijboom 2018-12-01 21:08:53 UTC
(In reply to Robert-André Mauchin from comment #5)
>  - Run the tests
> 
> 
> 
> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> [ ] = Manual review needed
> 
> 
> ===== MUST items =====
> 
> Generic:
> [x]: Package is licensed with an open-source compatible license and meets
>      other legal requirements as defined in the legal section of Packaging
>      Guidelines.
> [x]: License field in the package spec file matches the actual license.
>      Note: Checking patched sources after %prep for licenses. Licenses
>      found: "BSD 2-clause "Simplified" License", "*No copyright* BSD
>      2-clause "Simplified" License", "Unknown or generated". 31 files have
>      unknown license. Detailed output of licensecheck in
>      /home/bob/packaging/review/rubygem-xdg/review-rubygem-
>      xdg/licensecheck.txt
> [x]: License file installed when any subpackage combination is installed.
> [x]: Package contains no bundled libraries without FPC exception.
> [x]: Changelog in prescribed format.
> [x]: Sources contain only permissible code or content.
> [-]: Package contains desktop file if it is a GUI application.
> [-]: Development files must be in a -devel package
> [x]: Package uses nothing in %doc for runtime.
> [x]: Package consistently uses macros (instead of hard-coded directory
>      names).
> [x]: Package is named according to the Package Naming Guidelines.
> [x]: Package does not generate any conflict.
> [x]: Package obeys FHS, except libexecdir and /usr/target.
> [-]: If the package is a rename of another package, proper Obsoletes and
>      Provides are present.
> [x]: Requires correct, justified where necessary.
> [x]: Spec file is legible and written in American English.
> [-]: Package contains systemd file(s) if in need.
> [x]: Package is not known to require an ExcludeArch tag.
> [x]: Package complies to the Packaging Guidelines
> [x]: Package successfully compiles and builds into binary rpms on at least
>      one supported primary architecture.
> [x]: Package installs properly.
> [x]: Rpmlint is run on all rpms the build produces.
>      Note: There are rpmlint messages (see attachment).
> [x]: Package requires other packages for directories it uses.
> [x]: Package does not own files or directories owned by other packages.
> [x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
> [x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
>      beginning of %install.
> [x]: Macros in Summary, %description expandable at SRPM build time.
> [x]: Dist tag is present.
> [x]: Package does not contain duplicates in %files.
> [x]: Permissions on files are set properly.
> [x]: Package use %makeinstall only when make install DESTDIR=... doesn't
>      work.
> [x]: Package is named using only allowed ASCII characters.
> [x]: Package does not use a name that already exists.
> [x]: Package is not relocatable.
> [x]: Sources used to build the package match the upstream source, as
>      provided in the spec URL.
> [x]: Spec file name must match the spec package %{name}, in the format
>      %{name}.spec.
> [x]: File names are valid UTF-8.
> [x]: Large documentation must go in a -doc subpackage. Large could be size
>      (~1MB) or number of files.
>      Note: Documentation size is 0 bytes in 0 files.
> [x]: Packages must not store files under /srv, /opt or /usr/local
> 
> Ruby:
> [x]: Platform dependent files must all go under %{gem_extdir_mri}, platform
>      independent under %{gem_dir}.
> [x]: Gem package must not define a non-gem subpackage
> [x]: Macro %{gem_extdir} is deprecated.
> [x]: Gem package is named rubygem-%{gem_name}
> [x]: Package contains BuildRequires: rubygems-devel.
> [x]: Gem package must define %{gem_name} macro.
> [x]: Pure Ruby package must be built as noarch
> [x]: Package does not contain Requires: ruby(abi).
> 
> ===== SHOULD items =====
> 
> Generic:
> [-]: Avoid bundling fonts in non-fonts packages.
>      Note: Package contains font files
> [-]: If the source package does not include license text(s) as a separate
>      file from upstream, the packager SHOULD query upstream to include it.
> [x]: Final provides and requires are sane (see attachments).
> [-]: Fully versioned dependency in subpackages if applicable.
>      Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
>      xdg-doc
> [?]: Package functions as described.
> [x]: Latest version is packaged.
> [x]: Package does not include license text files separate from upstream.
> [-]: Description and summary sections in the package spec file contains
>      translations for supported Non-English languages, if available.
> [x]: Package should compile and build into binary rpms on all supported
>      architectures.
> [!]: %check is present and all tests pass.
> [x]: Packages should try to preserve timestamps of original installed
>      files.
> [x]: Reviewer should test that the package builds in mock.
> [x]: Buildroot is not present
> [x]: Package has no %clean section with rm -rf %{buildroot} (or
>      $RPM_BUILD_ROOT)
> [x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
> [x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
> [x]: Sources can be downloaded from URI in Source: tag
> [x]: SourceX is a working URL.
> [x]: Spec use %global instead of %define unless justified.
> 
> Ruby:
> [x]: Gem should use %gem_install macro.
> [x]: Gem package should exclude cached Gem.
> [x]: gems should not require rubygems package
> [x]: Specfile should use macros from rubygem-devel package.
> [x]: Test suite should not be run by rake.
> [x]: Test suite of the library should be run.
> 
> ===== EXTRA items =====
> 
> Generic:
> [x]: Rpmlint is run on all installed packages.
>      Note: There are rpmlint messages (see attachment).
> [x]: Spec file according to URL is the same as in SRPM.
> 
> 
> Rpmlint
> -------
> Checking: rubygem-xdg-2.2.3-1.fc30.noarch.rpm
>           rubygem-xdg-doc-2.2.3-1.fc30.noarch.rpm
>           rubygem-xdg-2.2.3-1.fc30.src.rpm
> rubygem-xdg.noarch: W: invalid-license BSD-2-Clause
> rubygem-xdg.noarch: W: no-documentation
> rubygem-xdg.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/.index
> rubygem-xdg.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/.cache
> rubygem-xdg.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/.cache
> rubygem-xdg.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.cache
> rubygem-xdg.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.cache
> rubygem-xdg.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.config
> rubygem-xdg.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.config
> rubygem-xdg.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.local
> rubygem-xdg.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/demo/fixtures/fakeroot/home/.local
> rubygem-xdg-doc.noarch: W: invalid-license BSD-2-Clause
> rubygem-xdg-doc.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/.cache
> rubygem-xdg-doc.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/.cache
> rubygem-xdg-doc.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.cache
> rubygem-xdg-doc.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.cache
> rubygem-xdg-doc.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.config
> rubygem-xdg-doc.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.config
> rubygem-xdg-doc.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.local
> rubygem-xdg-doc.noarch: W: hidden-file-or-dir
> /usr/share/gems/gems/xdg-2.2.3/test/fakeroot/home/.local
> rubygem-xdg.src: W: invalid-license BSD-2-Clause
> 3 packages and 0 specfiles checked; 0 errors, 21 warnings.

Thanks! I should've checked this before submitting a review request. I implemented the %check stage which executes the tests of this package and updated the license to: BSD. As for the "hidden-file-or-dir" messages I'm not sure what to do, those files are required for the unit tests of the package.

New Spec URL: https://copr-be.cloud.fedoraproject.org/results/dmeijboom/rubygem-xdg/fedora-rawhide-x86_64/00832214-rubygem-xdg/rubygem-xdg.spec
New SRPM URL: https://copr-be.cloud.fedoraproject.org/results/dmeijboom/rubygem-xdg/fedora-rawhide-x86_64/00832214-rubygem-xdg/rubygem-xdg-2.2.3-1.fc30.src.rpm

Comment 7 Robert-André Mauchin 2018-12-01 22:41:38 UTC
LGTM, package approved.

Comment 8 Christopher Brown 2018-12-02 22:07:11 UTC
Small nit - it would be good to have the source url/comments on how to locate and grab the Rakefile.

https://fedoraproject.org/wiki/Packaging:SourceURL#Git_Hosting_Services


Note You need to log in before you can comment on or make changes to this bug.